/*
chosts.h - unfinished host thing...
Copyright (C)2001  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Don't write to me at: kingsley@bananahead.com 

   Part of:
   BhPos, Copyright (C) 2001 Al Kingsley
   BhPos comes with ABSOLUTELY NO WARRANTY.

*/
#ifndef _BH_HOSTS_
#define _BH_HOSTS_

#include <list>

/**
 * @defgroup hosts Hosts Information
 * @{
 *
 * @ingroup serverlib
 * @{
 */

#ifndef sock_storage
typedef struct __sockaddr_storage{
   u_char ss_len;
   u_char ss_family;
   u_char padding[126];
}sock_storage;

typedef sock_storage sockst;
#endif


#define DenyThenAllow   1
#define AllowThenDeny   2
#define AllowAllDeny    3
#define DenyAllAllow    4

/* }@
 *
 * @ingroup hosts
 * @{
 */

class CHosts
{
private:
   sockaddr_in       sin4;
   sockaddr_in6      sin6;
   unsigned char     addrbuff[16];
   std::list<sockst> allowed;
   std::list<sockst> denied;
   int               order;

protected:
   int  ParseAddress(char *addr, sockst *ss);
   
   bool RemoveComments(char *addr);
   bool TrimWhiteSpace(char *addr);
   int  GetAddressParm(char *addr, sockst *parm);
   
   int  ParseIP4string(const char *addr, sockst *ss);
   int  ParseIP6string(const char *addr);
   bool CharToAddress(char *line, sockst *addr);

public:
   CHosts();
   ~CHosts();

   bool Load(char *allowed_file, char *denied_file, int o);
   bool ParseLine(char *);
   bool IsHostAllowed(char *);
};

/* }@ 
	}@ */

#endif   // _BH_HOSTS_
